


; ----------------------------------------------
;   Public functions
; ----------------------------------------------

Declare.l AY_SetMasterVolume(volume.f)		; 0 ... 1.0
Declare.f AY_GetMasterVolume()
Declare.l AY_SetRegister(reg.l,val.l)		; 0,1,2 - tone A,B,C; 3-noise; 4-mixer; 5,6,7 - volume A,B,C; 8 - envelope tone; 9 - envelope shape
Declare.l AY_GetRegister(reg.l)
Declare.l AY_Reset()
Declare.f AY_GetVolumeA()					; -32768 ... 32768
Declare.f AY_GetVolumeB()
Declare.f AY_GetVolumeC()
Declare.f AY_GetVolumeR()
Declare.f AY_GetVolumeL()

; ----------------------------------------------
;   Public callback functions
; ----------------------------------------------

Declare.l AY_UpdateSample(buffer.l)



; ----------------------------------------------
;   Private functions
; ----------------------------------------------

Declare.l AY_ResetFunction()
Declare.l AY_CreateVolumeTable()
Declare.f AY_Envelope_0_3__9()
Declare.f AY_Envelope_4_7__15()
Declare.f AY_Envelope_8()
Declare.f AY_Envelope_10()
Declare.f AY_Envelope_11()
Declare.f AY_Envelope_12()
Declare.f AY_Envelope_13()
Declare.f AY_Envelope_14()

; ----------------------------------------------
;   Private vars
; ----------------------------------------------

;- Vars

Global AY_FMaster.l = 1750000					; or 1773400 or 2010000
Global AY_FMasterLow.l = AY_FMaster / 16 		; 109375
Global AY_MixRate.l = AY_FMaster / 8
Global AY_MixStep.f = AY_MixRate / Sound_MixRate

Global AY_MasterVolume.f = 1.0
Global AY_MasterVolumeTemp.f = 1.0

Global AY_ToneA_Counter.f = 0			
Global AY_ToneA_Register.f = 0			
Global AY_ToneA_RegisterOriginal.l = 0			
Global AY_ToneA_Value.l = 0			

Global AY_ToneB_Counter.f = 0			
Global AY_ToneB_Register.f = 0			
Global AY_ToneB_RegisterOriginal.l = 0			
Global AY_ToneB_Value.l = 0			

Global AY_ToneC_Counter.f = 0			
Global AY_ToneC_Register.f = 0			
Global AY_ToneC_RegisterOriginal.l = 0			
Global AY_ToneC_Value.l = 0			

Global AY_VolumeA.f = 0			
Global AY_VolumeAOriginal.l = 0			
Global AY_VolumeB.f = 0			
Global AY_VolumeBOriginal.l = 0			
Global AY_VolumeC.f = 0			
Global AY_VolumeCOriginal.l = 0			

Global AY_Noise_Counter.f = 0			
Global AY_Noise_Register.f = 0			
Global AY_Noise_RegisterOriginal.l = 0			
Global AY_Noise_Value.l = 0	
Global AY_Noise_Buffer.l = $FFFF

Global AY_Mixer.l = 0			
Global AY_MixerNoiseA.l = 0			
Global AY_MixerNoiseB.l = 0			
Global AY_MixerNoiseC.l = 0			
Global AY_MixerToneA.l = 0			
Global AY_MixerToneB.l = 0			
Global AY_MixerToneC.l = 0			
Global AY_MixerA.l = 1			
Global AY_MixerB.l = 1			
Global AY_MixerC.l = 1	

Prototype.f Proto_AY_Envelope_ShapeFunction()
Global AY_Envelope_Shape.l = 0			
Global AY_Envelope_ShapeCounter.l = 0			
Global AY_Envelope_ShapeMode.l = 0			
Global AY_Envelope_ShapeFunction.Proto_AY_Envelope_ShapeFunction = @AY_Envelope_0_3__9()			

Global AY_Envelope_EnableA.l = 0			
Global AY_Envelope_EnableB.l = 0			
Global AY_Envelope_EnableC.l = 0			

Global AY_Envelope_Counter.f = 0			
Global AY_Envelope_Register.f = 0			
Global AY_Envelope_RegisterOriginal.l = 0			
Global AY_Envelope_Value.f = 0			

Global AY_MixedVolumeA.f = 0
Global AY_MixedVolumeATemp.f = 0
Global AY_MixedVolumeB.f = 0
Global AY_MixedVolumeBTemp.f = 0
Global AY_MixedVolumeC.f = 0
Global AY_MixedVolumeCTemp.f = 0

Global AY_MixedVolumeR.f = 0
Global AY_MixedVolumeRTemp.f = 0
Global AY_MixedVolumeL.f = 0
Global AY_MixedVolumeLTemp.f = 0

Global AY_MixedVolumeROld.f = 0
Global AY_MixedVolumeLOld.f = 0

Global AY_Filter.l = 1
Global AY_FilterHi.f = 0.85
Global AY_FilterLow.f = 0.99

Global AY_ResetFlag.l = 0

Global Dim AY_VolumeTable.f(256)			



;- Procedures

Procedure.l AY_UpdateVars()
; 	If AY_ResetFlag = 1
; 		AY_ResetFunction()
; 		AY_ResetFlag = 0
; 	Else
; 		AY_MixedVolumeA = AY_MixedVolumeATemp
; 		AY_MixedVolumeB = AY_MixedVolumeBTemp
; 		AY_MixedVolumeC = AY_MixedVolumeCTemp
; 		AY_MixedVolumeR = AY_MixedVolumeRTemp
; 		AY_MixedVolumeL = AY_MixedVolumeLTemp
; 		AY_MasterVolume = AY_MasterVolumeTemp
; 	EndIf
EndProcedure

Procedure.f AY_GetVolumeA()
	ProcedureReturn AY_MixedVolumeA
EndProcedure

Procedure.f AY_GetVolumeB()
	ProcedureReturn AY_MixedVolumeB
EndProcedure

Procedure.f AY_GetVolumeC()
	ProcedureReturn AY_MixedVolumeC
EndProcedure

Procedure.f AY_GetVolumeR()
	ProcedureReturn AY_MixedVolumeR
EndProcedure

Procedure.f AY_GetVolumeL()
	ProcedureReturn AY_MixedVolumeL
EndProcedure

Procedure.l AY_SetMasterVolume(vol.f)
	If vol<0 : vol=0 : EndIf
	If vol>1 : vol=1 : EndIf
	AY_MasterVolume = vol
EndProcedure

Procedure.f AY_GetMasterVolume()
	ProcedureReturn AY_MasterVolume
EndProcedure

Procedure.l AY_SetRegister(reg.l,val.l)
	Protected temp.l
	Select reg
		Case 0
			AY_ToneA_RegisterOriginal = val & $FFF
			AY_ToneA_Register = AY_ToneA_RegisterOriginal / AY_MixStep
			
		Case 1
			AY_ToneB_RegisterOriginal = val & $FFF
			AY_ToneB_Register = AY_ToneB_RegisterOriginal / AY_MixStep
			
		Case 2
			AY_ToneC_RegisterOriginal = val & $FFF
			AY_ToneC_Register = AY_ToneC_RegisterOriginal / AY_MixStep
			
		Case 3
			AY_Noise_RegisterOriginal = val & $1F
			AY_Noise_Register = AY_Noise_RegisterOriginal  / AY_MixStep * 2.0
			
		Case 4
			AY_Mixer = val & $3F
			temp = AY_Mixer
			AY_MixerToneA  = (temp & 1) ! 1  :  temp >> 1
			AY_MixerToneB  = (temp & 1) ! 1  :  temp >> 1
			AY_MixerToneC  = (temp & 1) ! 1  :  temp >> 1		
			AY_MixerNoiseA = (temp & 1) ! 1  :  temp >> 1
			AY_MixerNoiseB = (temp & 1) ! 1  :  temp >> 1
			AY_MixerNoiseC = (temp & 1) ! 1
			
			If AY_MixerToneA=0 And AY_MixerNoiseA=0
				AY_MixerA = 0
			Else
				AY_MixerA = 1
			EndIf
			
			If AY_MixerToneB=0 And AY_MixerNoiseB=0
				AY_MixerB = 0
			Else
				AY_MixerB = 1
			EndIf
			
			If AY_MixerToneC=0 And AY_MixerNoiseC=0
				AY_MixerC = 0
			Else
				AY_MixerC = 1
			EndIf
			
		Case 5
			AY_VolumeAOriginal = val & $1F
			AY_VolumeA = AY_VolumeTable( ((AY_VolumeAOriginal & $F) << 1) + 1 )
			AY_Envelope_EnableA = AY_VolumeAOriginal & $10
			
		Case 6
			AY_VolumeBOriginal = val & $1F
			AY_VolumeB = AY_VolumeTable( ((AY_VolumeBOriginal & $F) << 1) + 1 )
			AY_Envelope_EnableB = AY_VolumeBOriginal & $10
			
		Case 7
			AY_VolumeCOriginal = val & $1F
			AY_VolumeC = AY_VolumeTable( ((AY_VolumeCOriginal & $F) << 1) + 1 )
			AY_Envelope_EnableC = AY_VolumeCOriginal & $10
			
		Case 8
			AY_Envelope_RegisterOriginal = val & $FFFF
			AY_Envelope_Register = AY_Envelope_RegisterOriginal / AY_MixStep
			
		Case 9
			AY_Envelope_Shape = val & $F
			If AY_Envelope_Shape & 4
				AY_Envelope_ShapeCounter = -1
			Else
				AY_Envelope_ShapeCounter = 32
			EndIf			
			AY_Envelope_ShapeMode = 0
			Select AY_Envelope_Shape
				Case 0 To 3, 9
					AY_Envelope_ShapeFunction = @AY_Envelope_0_3__9()
				Case 4 To 7, 15
					AY_Envelope_ShapeFunction = @AY_Envelope_4_7__15()
				Case 8
					AY_Envelope_ShapeFunction = @AY_Envelope_8()
				Case 10
					AY_Envelope_ShapeFunction = @AY_Envelope_10()
				Case 11
					AY_Envelope_ShapeFunction = @AY_Envelope_11()
				Case 12
					AY_Envelope_ShapeFunction = @AY_Envelope_12()
				Case 13
					AY_Envelope_ShapeFunction = @AY_Envelope_13()
				Case 14
					AY_Envelope_ShapeFunction = @AY_Envelope_14()
			EndSelect
				
		Default
		
	EndSelect
EndProcedure

Procedure.l AY_GetRegister(reg.l)
	Select reg
		Case 0
			ProcedureReturn AY_ToneA_RegisterOriginal
		Case 1
			ProcedureReturn AY_ToneB_RegisterOriginal
		Case 2
			ProcedureReturn AY_ToneC_RegisterOriginal
		Case 3
			ProcedureReturn AY_Noise_RegisterOriginal
		Case 4
			ProcedureReturn AY_Mixer
		Case 5
			ProcedureReturn AY_VolumeAOriginal
		Case 6
			ProcedureReturn AY_VolumeBOriginal
		Case 7
			ProcedureReturn AY_VolumeCOriginal
		Case 8
			ProcedureReturn AY_Envelope_RegisterOriginal
		Case 9
			ProcedureReturn AY_Envelope_Shape
		Default
			ProcedureReturn  0
	EndSelect		
EndProcedure

Procedure.l AY_ResetFunction()
	Protected i.l
	
	If AY_ResetFlag = 1
		
		AY_CreateVolumeTable()
		
		For i = 0 To 9
			AY_SetRegister (i,0)
		Next
		
		AY_ToneA_Value = 0
		AY_ToneA_Counter = 0
		
		AY_ToneB_Value = 0
		AY_ToneB_Counter = 0
		
		AY_ToneC_Value = 0
		AY_ToneC_Counter = 0
		
		AY_Noise_Counter = 0
		AY_Noise_Value = 0
		
		AY_Envelope_Counter = 0
		AY_Envelope_Value = 0
		
		AY_MixedVolumeA = 0
		AY_MixedVolumeB = 0
		AY_MixedVolumeC = 0
		AY_MixedVolumeR = 0
		AY_MixedVolumeL = 0
		
		AY_MixedVolumeATemp = 0
		AY_MixedVolumeBTemp = 0
		AY_MixedVolumeCTemp = 0
		AY_MixedVolumeRTemp = 0
		AY_MixedVolumeLTemp = 0
		
		AY_MixedVolumeROld = 0
		AY_MixedVolumeLOld = 0
		
		AY_Noise_Buffer = $FFFF
	EndIf	
EndProcedure

Procedure.l AY_Reset()
	; AY_ResetFlag = 1
		
		AY_CreateVolumeTable()
		
		For i = 0 To 9
			AY_SetRegister (i,0)
		Next
		
		AY_ToneA_Value = 0
		AY_ToneA_Counter = 0
		
		AY_ToneB_Value = 0
		AY_ToneB_Counter = 0
		
		AY_ToneC_Value = 0
		AY_ToneC_Counter = 0
		
		AY_Noise_Counter = 0
		AY_Noise_Value = 0
		
		AY_Envelope_Counter = 0
		AY_Envelope_Value = 0
		
		AY_MixedVolumeA = 0
		AY_MixedVolumeB = 0
		AY_MixedVolumeC = 0
		AY_MixedVolumeR = 0
		AY_MixedVolumeL = 0
		
		AY_MixedVolumeATemp = 0
		AY_MixedVolumeBTemp = 0
		AY_MixedVolumeCTemp = 0
		AY_MixedVolumeRTemp = 0
		AY_MixedVolumeLTemp = 0
		
		AY_MixedVolumeROld = 0
		AY_MixedVolumeLOld = 0
		
		AY_Noise_Buffer = $FFFF
EndProcedure 

Procedure.l AY_CreateVolumeTable()
	Protected i.l

	For i=0 To 31
		AY_VolumeTable(i) = PeekF( ?AY_Volume_Data + (i<<2) )
	Next
EndProcedure 

Procedure.f AY_Envelope_0_3__9()
	If AY_Envelope_ShapeMode=0
		AY_Envelope_ShapeCounter-1
		If AY_Envelope_ShapeCounter<0
			AY_Envelope_ShapeCounter = 0
			AY_Envelope_ShapeMode=1
		EndIf
	EndIf
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.f AY_Envelope_4_7__15()
	If AY_Envelope_ShapeMode=0
		AY_Envelope_ShapeCounter+1
		If AY_Envelope_ShapeCounter>31
			AY_Envelope_ShapeMode=1
			AY_Envelope_ShapeCounter=0
		EndIf
	EndIf
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.f AY_Envelope_8()
	AY_Envelope_ShapeCounter - 1
	AY_Envelope_ShapeCounter & $1F
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.f AY_Envelope_10()
	If AY_Envelope_ShapeMode=0
		AY_Envelope_ShapeCounter-1
		If AY_Envelope_ShapeCounter<0
			AY_Envelope_ShapeMode=1
			AY_Envelope_ShapeCounter=0
		EndIf 
	Else
		AY_Envelope_ShapeCounter+1
		If AY_Envelope_ShapeCounter>31
			AY_Envelope_ShapeMode=0
			AY_Envelope_ShapeCounter=31
		EndIf 
	EndIf
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.f AY_Envelope_11()
	If AY_Envelope_ShapeMode=0
		AY_Envelope_ShapeCounter-1
		If AY_Envelope_ShapeCounter<0
			AY_Envelope_ShapeMode=1
			AY_Envelope_ShapeCounter=31
		EndIf
	EndIf
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.f AY_Envelope_12()
	AY_Envelope_ShapeCounter + 1
	AY_Envelope_ShapeCounter & $1F
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.f AY_Envelope_13()
	If AY_Envelope_ShapeMode=0
		AY_Envelope_ShapeCounter+1
		If AY_Envelope_ShapeCounter>31
			AY_Envelope_ShapeMode=0
			AY_Envelope_ShapeCounter=31
		EndIf
	EndIf
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter ) 
EndProcedure

Procedure.f AY_Envelope_14()
	If AY_Envelope_ShapeMode = 1
		AY_Envelope_ShapeCounter-1
		If AY_Envelope_ShapeCounter<0
			AY_Envelope_ShapeMode=1
			AY_Envelope_ShapeCounter=0
		EndIf 
	Else
		AY_Envelope_ShapeCounter+1
		If AY_Envelope_ShapeCounter>31
			AY_Envelope_ShapeMode=0
			AY_Envelope_ShapeCounter=31
		EndIf 
	EndIf
	ProcedureReturn AY_VolumeTable( AY_Envelope_ShapeCounter )
EndProcedure

Procedure.l AY_UpdateSample(buffer.l)		; update AY sample
		Protected r.w
		Protected l.w
		Protected k.l
		Protected va.f
		Protected vb.f
		Protected vc.f
		Protected na.l
		Protected nb.l
		Protected nc.l
		Protected d.f
		
		AY_ToneA_Counter + 1
		If AY_ToneA_Counter >= AY_ToneA_Register
			AY_ToneA_Counter - AY_ToneA_Register
			AY_ToneA_Value ! 1
		EndIf
		
		AY_ToneB_Counter + 1
		If AY_ToneB_Counter >= AY_ToneB_Register
			AY_ToneB_Counter - AY_ToneB_Register
			AY_ToneB_Value ! 1
		EndIf
		
		AY_ToneC_Counter + 1
		If AY_ToneC_Counter >= AY_ToneC_Register
			AY_ToneC_Counter - AY_ToneC_Register
			AY_ToneC_Value ! 1
		EndIf
		
		AY_Envelope_Counter + 1.0011
		If AY_Envelope_Counter >= AY_Envelope_Register
			AY_Envelope_Counter - AY_Envelope_Register
			AY_Envelope_Value = AY_Envelope_ShapeFunction()
		EndIf
		
		AY_Noise_Counter + 1
		If AY_Noise_Counter >= AY_Noise_Register
			AY_Noise_Counter - AY_Noise_Register
			
			AY_Noise_Value = (AY_Noise_Buffer >> 16) & 1
			AY_Noise_Buffer << 1
			na = (AY_Noise_Buffer >> 13 ) & 1
			nb = (AY_Noise_Buffer >> 16 ) & 1
			nc = (na ! nb) ;! 1
			AY_Noise_Buffer | nc
			
			;AY_Noise_Value = Random(1)
		EndIf
 
		If AY_Envelope_EnableA
			va = AY_Envelope_Value
		Else
			va = AY_VolumeA
		EndIf
		
		If AY_Envelope_EnableB
			vb = AY_Envelope_Value
		Else
			vb = AY_VolumeB
		EndIf
		
		If AY_Envelope_EnableC
			vc = AY_Envelope_Value
		Else
			vc = AY_VolumeC
		EndIf
		
		k = AY_MixerA
		If AY_MixerToneA   :  k = AY_ToneA_Value  :  EndIf
		If AY_MixerNoiseA  :  k & AY_Noise_Value  :  EndIf		
		AY_MixedVolumeA = va * ( k - 0.5 )
		
		k = AY_MixerB
		If AY_MixerToneB   :  k = AY_ToneB_Value  :  EndIf
		If AY_MixerNoiseB  :  k & AY_Noise_Value  :  EndIf		
		AY_MixedVolumeB = vb * ( k - 0.5 )
		
		k = AY_MixerC
		If AY_MixerToneC   :  k = AY_ToneC_Value  :  EndIf
		If AY_MixerNoiseC  :  k & AY_Noise_Value  :  EndIf
		AY_MixedVolumeC = vc * ( k - 0.5 )
		
		AY_MixedVolumeR = ( AY_MixedVolumeA*0.5 + AY_MixedVolumeC*0.25 );+ AY_MixedVolumeB*0.0625 )
		AY_MixedVolumeL = ( AY_MixedVolumeB*0.5 + AY_MixedVolumeC*0.25 );+ AY_MixedVolumeA*0.0625 )
		
		;;;AY_MixedVolumeR = ( AY_MixedVolumeC*0.25 );+ AY_MixedVolumeB*0.0625 )
		;;;AY_MixedVolumeL = ( AY_MixedVolumeC*0.25 );+ AY_MixedVolumeA*0.0625 )
		
		If AY_Filter
			AY_MixedVolumeROld = AY_MixedVolumeROld * AY_FilterLow + ((AY_MixedVolumeR - AY_MixedVolumeROld) * AY_FilterHi)
			AY_MixedVolumeLOld = AY_MixedVolumeLOld * AY_FilterLow + ((AY_MixedVolumeL - AY_MixedVolumeLOld) * AY_FilterHi)
			l = AY_MasterVolume * AY_MixedVolumeROld
			r = AY_MasterVolume * AY_MixedVolumeLOld
		Else
			l = AY_MasterVolume * AY_MixedVolumeR
			r = AY_MasterVolume * AY_MixedVolumeL		
		EndIf
	
		PokeW(buffer+2, r )
		PokeW(buffer, l )

EndProcedure



;- Data section

;{ Data
DataSection
	AY_Volume_Data:	
	Data.f 0, 30,  190,  286, 375, 470, 560, 664, 866, 1130, 1515, 1803, 2253, 2848, 3351, 3862, 4844, 6058, 7290, 8559, 10474, 12878, 15297, 17787, 21500, 26172, 30866, 35676, 42664, 50986, 58842, 65535
	AY_Volume_Data1:
	Data.f 0,  0,  190,  286, 375, 470, 560, 664, 866, 1130, 1515, 1803, 2253, 2848, 3351, 3862, 4844, 6058, 7290, 8559, 10474, 12878, 15297, 17787, 21500, 26172, 30866, 35676, 42664, 50986, 58842, 65535
	
; 	(0, 0, $F8, $1C2, $29E, $33A, $3F2, $4D7, $610, $77F, $90A, $A42,
;     $C3B, $EC2, $1137, $13A7, $1750, $1BF9, $20DF, $2596, $2C9D, $3579,
;     $3E55, $4768, $54FF, $6624, $773B, $883F, $A1DA, $C0FC, $E094, $FFFF);

EndDataSection
;}



; IDE Options = PureBasic 4.10 (Windows - x86)
; CursorPosition = 572
; FirstLine = 241
; Folding = AAAo
; DisableDebugger